﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Dynamic;
using System.Linq;
using System.Text;


namespace WpfApplication2
{
    public class CurveData :INotifyPropertyChanged
    {
        private string _moniker;
        private string _issuerName;
        private double _recovery;
        private Dictionary<string, double? > _spreads;
        private string _parentId;
        private CurveMarking _curveMarking= new CurveMarking();
        private List<double> speadList = new List<double>();
        
        public CurveData()
        {
            _spreads = new Dictionary<string, double?>();
            
        }

        // If you try to get a value of a property 
        // not defined in the class, this method is called.
  //      public override bool TryGetMember(
  //          GetMemberBinder binder, out object result)
  //      {
  //          // Converting the property name to lowercase
  //          // so that property names become case-insensitive.
  //          string name = binder.Name.ToLower();

  //          // If the property name is found in a dictionary,
  //          // set the result parameter to the property value and return true.
  //          // Otherwise, return false.
  //result =_spreads[name];
  //          return true;
        //}



        public double? Index { get; set; }
        public double? Index2 { get; set; }
        public string Moniker
        {
            get { return _moniker; }
            set
            {
                _moniker = value;
                OnPropertyChanged("Moniker");
            }
        }

        public string IssuerName
        {
            get { return _issuerName; }
            set
            {
                _issuerName = value;
                _curveMarking.Ticker = value;
                OnPropertyChanged("IssuerName");
            }
        }

        public double Recovery
        {
            get { return _recovery; }
            set
            {
                _recovery = value;
                OnPropertyChanged("Recovery");
            }
        }

        public Dictionary<string, double?> Spreads
        {
            get { return _spreads; }
            set
            {
                _spreads = value;
                OnPropertyChanged("Spreads");
            }
        }

        public string ParentId
        {
            get { return _parentId; }
            set { _parentId = value;
            OnPropertyChanged("ParentId");
            }
        }

        public CurveMarking CurveMarking
        {
            get { return _curveMarking; }
            set { _curveMarking = value;
            OnPropertyChanged("CurveMarking");
            }
        }

        public List<double> SpeadList
        {
            get { return speadList; }
            set { speadList = value;
            OnPropertyChanged("SpeadList");
            }
        }

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;



        public void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null && propertyName != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
        #endregion
    }


    public class CurveMarking : INotifyPropertyChanged
    {
        private string _curveTicker;

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        public string Ticker
        {
            get { return _curveTicker; }
            set { _curveTicker = value;
            OnPropertyChanged("Ticker");
            }
        }


        public void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null && propertyName != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
        
        #endregion
    }
}
