﻿using System;
using System.Collections.ObjectModel;
using System.Windows;
using Steema.TeeChart.WPF;
using WpfApplication2;

namespace TeechartSample
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ObservableCollection<CurveData> curves= new ObservableCollection<CurveData>();
        private int count;
        private Random rr = new Random();
        private TChart tchart;
        

        public MainWindow()
        {
            InitializeComponent();
            tchart = new TChart();
            grid1.Children.Add(tchart);
            PopulateData();

            tchart.Aspect.View3D = false;
            tchart.Legend.Visible = false;
            tchart.Walls.Back.Visible = false;
            AddSeries();
            
        }

        private void AddSeries()
        {
            Steema.TeeChart.WPF.Styles.Line line = new Steema.TeeChart.WPF.Styles.Line();
            line.DataSource = curves;
            line.XValues.DataMember = "Index";
            line.YValues.DataMember = "Index2";
            
            tchart.Series.Add(line);
        }

        private void PopulateData()
        {
            for(int i=0;i<15;i++)
            {
                AddRow();
            }
            //curves[0].Index2 = 50.000;
            //curves[1].Index2 = 60.000;
            //curves[2].Index2 = 77.000;
            //curves[3].Index2 = 95.000;
            //curves[4].Index2 = 105.000;
            //curves[5].Index2 = 109.670;
            //curves[6].Index2 = 113.00;
            //curves[7].Index2 = 116.760;
            //curves[8].Index2 =122.000;
            //curves[9].Index2 = 117.180;
            //curves[10].Index2 = 117.180;
            //curves[11].Index2 = 117.180;

            curves[0].Index2 = 11.438;
            curves[1].Index2 = 26.072;
            curves[2].Index2 = 55.339;
            curves[3].Index2 = 58.670;
            curves[4].Index2 = 62.000;
            curves[5].Index2 = 68.000;
            curves[6].Index2 = 74.000;
            curves[7].Index2 = 76.000;
            curves[8].Index2 = 78.000;
            curves[9].Index2 = 79.333;
            curves[10].Index2 = 80.667;
            curves[11].Index2 = 82.000;
            curves[12].Index2 = 82.000;
            curves[13].Index2 = 82.000;
            curves[14].Index2 = 82.000;

        }

        private CurveData AddRow()
        {
            
            CurveData curve = new CurveData();
            curve.Index = count;
            curve.Index2 = count * rr.Next(10, 20);
            curve.Moniker = "Moniker" + count;
            curve.IssuerName = "Issuer" + count;
            curve.Recovery = count * rr.NextDouble();
            curve.Spreads["3M"] = count;
           curve.SpeadList.Add(curve.Spreads["3M"].Value);
            curve.Spreads["6M"] = count * rr.Next(10, 20);
            curve.Spreads["1Y"] = count * rr.Next(20, 30);
            curve.Spreads["2Y"] = count * rr.Next(30, 40);
            curves.Add(curve);
            count++;
            return curve;
        }
    }
}
